diff --git a/src/cracker.c b/src/cracker.c
index 3c0c8939ef..7625d12012 100644
--- a/src/cracker.c
+++ b/src/cracker.c
@@ -285,6 +285,8 @@ static void crk_remove_salt(struct db_salt *salt)
                       (((fmt_data*)(b))->size) : (crk_params->binary_size))
 
 #define BLOB_FREE(b) do { if ((crk_params->flags & FMT_BLOB) &&	  \
+                              (b) &&	  \
+                              (fmt_data*)(b) &&	  \
                               (((fmt_data*)(b))->flags & FMT_DATA_ALLOC)) \
 			MEM_FREE(((fmt_data*)(b))->blob); } while (0)
 
diff --git a/src/formats.c b/src/formats.c
index 7966e90937..62090ec45d 100644
--- a/src/formats.c
+++ b/src/formats.c
@@ -335,7 +335,9 @@ static char* is_key_right(struct fmt_main *format, int index,
 #define BLOB_SIZE(b) ((format->params.flags & FMT_BLOB) ?	  \
                       (((fmt_data*)(b))->size) : (format->params.binary_size))
 
-#define BLOB_FREE(b) do { if ((b) && (format->params.flags & FMT_BLOB) &&	  \
+#define BLOB_FREE(b) do { if ((format->params.flags & FMT_BLOB) &&	  \
+                              (b) &&	  \
+                              (fmt_data*)(b) &&	  \
                               (((fmt_data*)(b))->flags & FMT_DATA_ALLOC)) \
 			MEM_FREE(((fmt_data*)(b))->blob); } while (0)
 
@@ -1631,7 +1633,7 @@ char *fmt_self_test(struct fmt_main *format, struct db_main *db)
 	self_test_running = 0;
 
 	MEM_FREE(salt_alloc);
-	//BLOB_FREE(binary_alloc);
+	BLOB_FREE(binary_alloc);
 	MEM_FREE(binary_alloc);
 
 	return retval;
diff --git a/src/loader.c b/src/loader.c
index 84e29c6452..c7dabf298c 100644
--- a/src/loader.c
+++ b/src/loader.c
@@ -899,7 +899,9 @@ static struct list_main *ldr_init_words(char *login, char *gecos, char *home)
 #define BLOB_SIZE(b) ((format->params.flags & FMT_BLOB) ?	  \
                       (((fmt_data*)(b))->size) : (format->params.binary_size))
 
-#define BLOB_FREE(b) do { if ((b) && (format->params.flags & FMT_BLOB) && \
+#define BLOB_FREE(b) do { if ((format->params.flags & FMT_BLOB) &&	  \
+                              (b) &&	  \
+                              (fmt_data*)(b) &&	  \
                               (((fmt_data*)(b))->flags & FMT_DATA_ALLOC)) \
 			MEM_FREE(((fmt_data*)(b))->blob); } while (0)
 
diff --git a/src/opencl_common.c b/src/opencl_common.c
index 43aeece2ff..3c34e645c1 100644
--- a/src/opencl_common.c
+++ b/src/opencl_common.c
@@ -1567,6 +1567,8 @@ static void* fill_opencl_device(size_t gws, void **binary)
 }
 
 #define BLOB_FREE(b) do { if ((self->params.flags & FMT_BLOB) &&	  \
+                              (b) &&	  \
+                              (fmt_data*)(b) &&	  \
                               (((fmt_data*)(b))->flags & FMT_DATA_ALLOC)) \
 			MEM_FREE(((fmt_data*)(b))->blob); } while (0)
 
